/*
 * Copyright 2007-2009 Jiemamy Project and the Others.
 * Created on 2008/12/18
 *
 * This file is part of Jiemamy.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.jiemamy;

import java.util.EnumSet;
import java.util.List;
import java.util.Set;

import org.jiemamy.internal.enhance.ViewDomSerializerEnhancePointcut;
import org.jiemamy.internal.enhance.ViewDomSerializerEnhancer;
import org.jiemamy.internal.enhance.ViewFacadeEnhancePointcut;
import org.jiemamy.internal.enhance.ViewFacadeEnhancer;
import org.jiemamy.internal.enhance.ViewFactoryExtensionEnhancePointcut;
import org.jiemamy.internal.enhance.ViewFactoryExtensionEnhancer;
import org.jiemamy.utils.CollectionsUtil;
import org.jiemamy.utils.enhancer.Enhance;
import org.jiemamy.xml.JiemamyNamespace;
import org.jiemamy.xml.ViewNamespace;

/**
 * Jiemamy {@link Artemis} Implementationに対する、Jiemamy View Specification拡張クラス。
 * 
 * @author daisuke
 */
public class ArtemisView implements ArtemisExtender {
	
	public List<Enhance> getEnhances() {
		List<Enhance> enhances = CollectionsUtil.newArrayList();
		
		enhances.add(new Enhance(new ViewFactoryExtensionEnhancePointcut(), new ViewFactoryExtensionEnhancer()));
//		enhances.add(new Enhance(new ViewFactoryExtensionEnhancePointcut2(), new ViewFactoryExtensionEnhancer2()));
		enhances.add(new Enhance(new ViewDomSerializerEnhancePointcut(), new ViewDomSerializerEnhancer()));
		enhances.add(new Enhance(new ViewFacadeEnhancePointcut(), new ViewFacadeEnhancer()));
		
		return enhances;
	}
	
	public JiemamyNamespace[] getNamespaces() {
		return ViewNamespace.values();
	}
	
	public Set<? extends OptionalSpec> getSpecs() {
		return EnumSet.of(OfficialSpecs.VIEW);
	}
	
}
