/*
 * Copyright 2007-2009 MIYAMOTO Daisuke, jiemamy.org and the Others.
 * Created on 2009/01/01
 *
 * This file is part of Jiemamy.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.jiemamy.experimental.builder;

import org.jiemamy.model.entity.ViewModel;

/**
 * {@link ViewModel}を簡単に構築するためのビルダインターフェイス。
 * 
 * @since 0.2
 * @author daisuke
 */
public interface ViewBuilder extends JiemamyBuilder<ViewModel> {
	
	/**
	 * VIEW定義SELECT文を設定する。
	 * 
	 * @param definition VIEW定義SELECT文
	 * @return {@code this}
	 * @since 0.2
	 */
	ViewBuilder definition(String definition);
	
	/**
	 * ビュー名を設定する。
	 * 
	 * @param name ビュー名
	 * @return {@code this}
	 * @since 0.2
	 */
	ViewBuilder setName(String name);
	
}
