/*
 * Copyright 2007-2009 Jiemamy Project and the Others.
 * Created on 2008/12/10
 *
 * This file is part of Jiemamy.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.jiemamy.model.datatype.adapter;

import org.jiemamy.model.Adapter;
import org.jiemamy.model.AdapterType;
import org.jiemamy.model.datatype.DataTypeAdapter;

/**
 * シリアル（通し番号）型であることを表すアダプタ。
 * 
 * @author daisuke
 */
@Adapter(AdapterType.MODEL)
public class SerialDataTypeAdapter implements DataTypeAdapter {
	
	/** シリアル（通し番号）型であるどうか */
	private Boolean serial;
	

	public void copy(DataTypeAdapter src) {
		// nothing to do
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		final SerialDataTypeAdapter other = (SerialDataTypeAdapter) obj;
		if (serial == null) {
			if (other.serial != null) {
				return false;
			}
		} else if (serial.equals(other.serial) == false) {
			return false;
		}
		return true;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((serial == null) ? 0 : serial.hashCode());
		return result;
	}
	
	/**
	 * シリアル（通し番号）型であるどうかを取得する。
	 * 
	 * @return シリアル（通し番号）型であれば{@code true}
	 */
	public Boolean isSerial() {
		return serial;
	}
	
	/**
	 * シリアル（通し番号）型であるどうかを設定する。
	 * 
	 * @param serial シリアル（通し番号）型であるどうか
	 */
	public void setSerial(Boolean serial) {
		this.serial = serial;
	}
	
	@Override
	public String toString() {
		if (serial != null && serial) {
			return "SERIAL";
		}
		return "";
	}
	
}
