/*
 * Copyright 2007-2009 Jiemamy Project and the Others.
 * Created on 2008/12/19
 *
 * This file is part of Jiemamy.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.jiemamy.utils;

import org.apache.commons.lang.BooleanUtils;

import org.jiemamy.composer.Exporter;

/**
 * {@link Exporter}に対する非処理指示可能を表すアダプタ実装。
 * 
 * @author daisuke
 */
public class DisablableImpl implements Disablable {
	
	private Boolean disabled;
	

	public Boolean isDisabled() {
		return disabled;
	}
	
	public void setDisabled(Boolean disabled) {
		this.disabled = disabled;
	}
	
	@Override
	public String toString() {
		return BooleanUtils.toString(disabled, "disabled", "enabled", "");
	}
}
