/*
 * Copyright 2007-2009 Jiemamy Project and the Others.
 *
 * This file is part of Jiemamy.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.jiemamy.utils;

/**
 * リソースが見つからなかったときにスローされる例外クラス。
 * 
 * @author j5ik2o
 */
@SuppressWarnings("serial")
public class ResourceNotFoundException extends Exception {
	
	private String path;
	

	/**
	 * {@link ResourceNotFoundException}を作成する。
	 * 
	 * @param path パス
	 */
	public ResourceNotFoundException(String path) {
		super(path);
		this.path = path;
	}
	
	/**
	 * パスを返します。
	 * 
	 * @return パス
	 */
	public String getPath() {
		return path;
	}
}
