/* Generated By:JavaCC: Do not edit this line. GtreeParser0.java */
/*
 * Copyright 2009 Jiemamy Project and the Others.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.jiemamy.utils.gtree.text;

import java.util.Collections;
import java.util.ArrayList;
import java.util.List;

import org.jiemamy.utils.gtree.model.*;

class GtreeParser0 implements GtreeParser0Constants {

    private ThreadLocal<Variables> variables = new ThreadLocal<Variables>();

    /**
     * Parse and returns the analyzed Generic Tree Model.
     * @return the analyzed model
     * @throws ParseException if parse was failed
     */
    public Value parse(Variables vars) throws ParseException {
        variables.set(vars);
        try {
            return script();
        }
        finally {
            variables.set(null);
        }
    }

    private Value resolve(Token variable) throws ParseException {
        Variables vars = variables.get();
        if (vars == null) {
            vars = Variables.NULL;
        }
        return vars.resolve(variable);
    }

    private static <T> List<T> list() {
        return new ArrayList<T>();
    }

  final private Value script() throws ParseException {
    Value value;
    value = value();
    jj_consume_token(0);
        {if (true) return value;}
    throw new Error("Missing return statement in function");
  }

  final private Value value() throws ParseException {
    Value value;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case STRING:
      value = terminal();
        {if (true) return value;}
      break;
    case 11:
      value = orderedList();
        {if (true) return value;}
      break;
    case 9:
      value = unorderedList();
        {if (true) return value;}
      break;
    case 7:
      value = record();
        {if (true) return value;}
      break;
    case VARIABLE:
      value = variable();
        {if (true) return value;}
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final private Terminal terminal() throws ParseException {
    String string;
    string = string();
        {if (true) return Terminal.of(string);}
    throw new Error("Missing return statement in function");
  }

  final private Sequence orderedList() throws ParseException {
    List<Value> valueList;
    jj_consume_token(11);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 7:
    case 9:
    case 11:
    case VARIABLE:
    case STRING:
      valueList = valueList();
      break;
    default:
      jj_la1[1] = jj_gen;
            valueList = Collections.emptyList();
    }
    jj_consume_token(12);
        {if (true) return Sequence.ordered(valueList);}
    throw new Error("Missing return statement in function");
  }

  final private Sequence unorderedList() throws ParseException {
    List<Value> valueList;
    jj_consume_token(9);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 7:
    case 9:
    case 11:
    case VARIABLE:
    case STRING:
      valueList = valueList();
      break;
    default:
      jj_la1[2] = jj_gen;
            valueList = Collections.emptyList();
    }
    jj_consume_token(10);
        {if (true) return Sequence.unordered(valueList);}
    throw new Error("Missing return statement in function");
  }

  final private Record record() throws ParseException {
    List<Entry> entryList;
    jj_consume_token(7);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 7:
    case 9:
    case 11:
    case VARIABLE:
    case STRING:
      entryList = entryList();
      break;
    default:
      jj_la1[3] = jj_gen;
            entryList = Collections.emptyList();
    }
    jj_consume_token(8);
        {if (true) return Record.of(entryList);}
    throw new Error("Missing return statement in function");
  }

  final private Value variable() throws ParseException {
    Token t;
    t = jj_consume_token(VARIABLE);
        {if (true) return resolve(t);}
    throw new Error("Missing return statement in function");
  }

  final private List<Value> valueList() throws ParseException {
    Value elem;
    List<Value> list = list();
    elem = value();
        list.add(elem);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 13:
        ;
        break;
      default:
        jj_la1[4] = jj_gen;
        break label_1;
      }
      jj_consume_token(13);
      elem = value();
            list.add(elem);
    }
        {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final private List<Entry> entryList() throws ParseException {
    Entry elem;
    List<Entry> list = list();
    elem = entry();
        list.add(elem);
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 13:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_2;
      }
      jj_consume_token(13);
      elem = entry();
            list.add(elem);
    }
        {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final private Entry entry() throws ParseException {
    Value key;
    Value value;
    key = value();
    jj_consume_token(14);
    value = value();
        {if (true) return Entry.of(key, value);}
    throw new Error("Missing return statement in function");
  }

  final private String string() throws ParseException {
    Token t;
    t = jj_consume_token(STRING);
        String s = t.image;
        {if (true) return JavaEscape.unescape(s.substring(1, s.length() - 1));}
    throw new Error("Missing return statement in function");
  }

  /** Generated Token Manager. */
  public GtreeParser0TokenManager token_source;
  SimpleCharStream jj_input_stream;
  /** Current token. */
  public Token token;
  /** Next token. */
  public Token jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[6];
  static private int[] jj_la1_0;
  static {
      jj_la1_init_0();
   }
   private static void jj_la1_init_0() {
      jj_la1_0 = new int[] {0x18a80,0x18a80,0x18a80,0x18a80,0x2000,0x2000,};
   }

  /** Constructor with InputStream. */
  public GtreeParser0(java.io.InputStream stream) {
     this(stream, null);
  }
  /** Constructor with InputStream and supplied encoding */
  public GtreeParser0(java.io.InputStream stream, String encoding) {
    try { jj_input_stream = new SimpleCharStream(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source = new GtreeParser0TokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream) {
     ReInit(stream, null);
  }
  /** Reinitialise. */
  public void ReInit(java.io.InputStream stream, String encoding) {
    try { jj_input_stream.ReInit(stream, encoding, 1, 1); } catch(java.io.UnsupportedEncodingException e) { throw new RuntimeException(e); }
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }

  /** Constructor. */
  public GtreeParser0(java.io.Reader stream) {
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new GtreeParser0TokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }

  /** Constructor with generated Token Manager. */
  public GtreeParser0(GtreeParser0TokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }

  /** Reinitialise. */
  public void ReInit(GtreeParser0TokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 6; i++) jj_la1[i] = -1;
  }

  private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }


/** Get the next Token. */
  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

/** Get the specific Token. */
  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.List jj_expentries = new java.util.ArrayList();
  private int[] jj_expentry;
  private int jj_kind = -1;

  /** Generate ParseException. */
  public ParseException generateParseException() {
    jj_expentries.clear();
    boolean[] la1tokens = new boolean[20];
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 6; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 20; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.add(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.get(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  /** Enable tracing. */
  final public void enable_tracing() {
  }

  /** Disable tracing. */
  final public void disable_tracing() {
  }

}
